/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Call.xs. Do not edit this file, edit Call.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Call.xs"
/* 
 * Filename : Call.xs
 * 
 * Author   : Paul Marquess 
 * Date     : 11th November 2001
 * Version  : 1.06
 *
 *    Copyright (c) 1995-2001 Paul Marquess. All rights reserved.
 *       This program is free software; you can redistribute it and/or
 *              modify it under the same terms as Perl itself.
 *
 */

#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef _NOT_CORE
#  include "ppport.h"
#endif

/* Internal defines */
#define PERL_MODULE(s)		IoBOTTOM_NAME(s)
#define PERL_OBJECT(s)		IoTOP_GV(s)
#define FILTER_ACTIVE(s)	IoLINES(s)
#define BUF_OFFSET(sv)  	IoPAGE_LEN(sv)
#define CODE_REF(sv)  		IoPAGE(sv)

#define SET_LEN(sv,len) \
        do { SvPVX(sv)[len] = '\0'; SvCUR_set(sv, len); } while (0)


/* Global Data */

#define MY_CXT_KEY "Filter::Util::Call::_guts" XS_VERSION
 
typedef struct {
    int x_fdebug ;
    int x_current_idx ;
} my_cxt_t;
 
START_MY_CXT
 
#define fdebug          (MY_CXT.x_fdebug)
#define current_idx     (MY_CXT.x_current_idx)


static I32
filter_call(pTHX_ int idx, SV *buf_sv, int maxlen)
{
    dMY_CXT;
    SV   *my_sv = FILTER_DATA(idx);
    char *nl = "\n";
    char *p;
    char *out_ptr;
    int n;

    if (fdebug)
	warn("**** In filter_call - maxlen = %d, out len buf = %d idx = %d my_sv = %d [%s]\n", 
		maxlen, SvCUR(buf_sv), idx, SvCUR(my_sv), SvPVX(my_sv) ) ;

    while (1) {

	/* anything left from last time */
	if ((n = SvCUR(my_sv))) {

	    out_ptr = SvPVX(my_sv) + BUF_OFFSET(my_sv) ;

	    if (maxlen) { 
		/* want a block */ 
		if (fdebug)
		    warn("BLOCK(%d): size = %d, maxlen = %d\n", 
			idx, n, maxlen) ;

	        sv_catpvn(buf_sv, out_ptr, maxlen > n ? n : maxlen );
		if(n <= maxlen) {
		    BUF_OFFSET(my_sv) = 0 ;
	            SET_LEN(my_sv, 0) ;
		}
		else {
		    BUF_OFFSET(my_sv) += maxlen ;
	            SvCUR_set(my_sv, n - maxlen) ;
		}
	        return SvCUR(buf_sv);
	    }
	    else {
		/* want lines */
                if ((p = ninstr(out_ptr, out_ptr + n - 1, nl, nl))) {

	            sv_catpvn(buf_sv, out_ptr, p - out_ptr + 1);

	            n = n - (p - out_ptr + 1);
		    BUF_OFFSET(my_sv) += (p - out_ptr + 1);
	            SvCUR_set(my_sv, n) ;
	            if (fdebug)
		        warn("recycle %d - leaving %d, returning %d [%s]", 
				idx, n, SvCUR(buf_sv), SvPVX(buf_sv)) ;

	            return SvCUR(buf_sv);
	        }
	        else /* no EOL, so append the complete buffer */
	            sv_catpvn(buf_sv, out_ptr, n) ;
	    }
	    
	}


	SET_LEN(my_sv, 0) ;
	BUF_OFFSET(my_sv) = 0 ;

	if (FILTER_ACTIVE(my_sv))
	{
    	    dSP ;
    	    int count ;

            if (fdebug)
		warn("gonna call %s::filter\n", PERL_MODULE(my_sv)) ;

    	    ENTER ;
    	    SAVETMPS;
	
	    SAVEINT(current_idx) ; 	/* save current idx */
	    current_idx = idx ;

	    SAVESPTR(DEFSV) ;	/* save $_ */
	    /* make $_ use our buffer */
	    DEFSV = sv_2mortal(newSVpv("", 0)) ; 

    	    PUSHMARK(sp) ;

	    if (CODE_REF(my_sv)) {
	    /* if (SvROK(PERL_OBJECT(my_sv)) && SvTYPE(SvRV(PERL_OBJECT(my_sv))) == SVt_PVCV) { */
    	        count = perl_call_sv((SV*)PERL_OBJECT(my_sv), G_SCALAR);
	    }
	    else {
                XPUSHs((SV*)PERL_OBJECT(my_sv)) ;  
	
    	        PUTBACK ;

    	        count = perl_call_method("filter", G_SCALAR);
	    }

    	    SPAGAIN ;

            if (count != 1)
	        croak("Filter::Util::Call - %s::filter returned %d values, 1 was expected \n", 
			PERL_MODULE(my_sv), count ) ;
    
	    n = POPi ;

	    if (fdebug)
	        warn("status = %d, length op buf = %d [%s]\n",
		     n, SvCUR(DEFSV), SvPVX(DEFSV) ) ;
	    if (SvCUR(DEFSV))
	        sv_setpvn(my_sv, SvPVX(DEFSV), SvCUR(DEFSV)) ; 

    	    PUTBACK ;
    	    FREETMPS ;
    	    LEAVE ;
	}
	else
	    n = FILTER_READ(idx + 1, my_sv, maxlen) ;

 	if (n <= 0)
	{
	    /* Either EOF or an error */

	    if (fdebug) 
	        warn ("filter_read %d returned %d , returning %d\n", idx, n,
	            (SvCUR(buf_sv)>0) ? SvCUR(buf_sv) : n);

	    /* PERL_MODULE(my_sv) ; */
	    /* PERL_OBJECT(my_sv) ; */
	    filter_del(filter_call); 

	    /* If error, return the code */
	    if (n < 0)
		return n ;

	    /* return what we have so far else signal eof */
	    return (SvCUR(buf_sv)>0) ? SvCUR(buf_sv) : n;
	}

    }
}



#line 199 "Call.c"
#define IDX		current_idx

XS(XS_Filter__Util__Call_filter_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_Filter__Util__Call_filter_read)
{
    dXSARGS;
    if (items < 0 || items > 1)
	Perl_croak(aTHX_ "Usage: Filter::Util::Call::filter_read(size=0)");
    {
	int	size;
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    size = 0;
	else {
	    size = (int)SvIV(ST(0));
	}
#line 200 "Call.xs"
	{
    	    dMY_CXT;
	    SV * buffer = DEFSV ;

	    RETVAL = FILTER_READ(IDX + 1, buffer, size) ;
	}
#line 225 "Call.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Filter__Util__Call_real_import); /* prototype to pass -Wmissing-prototypes */
XS(XS_Filter__Util__Call_real_import)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Filter::Util::Call::real_import(object, perlmodule, coderef)");
    SP -= items;
    {
	SV *	object = ST(0);
	char *	perlmodule = (char *)SvPV_nolen(ST(1));
	int	coderef = (int)SvIV(ST(2));
#line 218 "Call.xs"
    {
        SV * sv = newSV(1) ;

        (void)SvPOK_only(sv) ;
        filter_add(filter_call, sv) ;

	PERL_MODULE(sv) = savepv(perlmodule) ;
	PERL_OBJECT(sv) = (GV*) newSVsv(object) ;
	FILTER_ACTIVE(sv) = TRUE ;
        BUF_OFFSET(sv) = 0 ;
	CODE_REF(sv)   = coderef ;

        SvCUR_set(sv, 0) ;

    }
#line 259 "Call.c"
	PUTBACK;
	return;
    }
}


XS(XS_Filter__Util__Call_filter_del); /* prototype to pass -Wmissing-prototypes */
XS(XS_Filter__Util__Call_filter_del)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Filter::Util::Call::filter_del()");
    {
#line 237 "Call.xs"
        dMY_CXT;
	if (PL_rsfp_filters && IDX <= av_len(PL_rsfp_filters) && FILTER_DATA(IDX) && FILTER_ACTIVE(FILTER_DATA(IDX)))
	    FILTER_ACTIVE(FILTER_DATA(IDX)) = FALSE ;
#line 277 "Call.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Filter__Util__Call_unimport); /* prototype to pass -Wmissing-prototypes */
XS(XS_Filter__Util__Call_unimport)
{
    dXSARGS;
    SP -= items;
    {
	char *	package;

	if (items < 1)
	    package = "Filter::Util::Call";
	else {
	    package = (char *)SvPV_nolen(ST(0));
	}
#line 247 "Call.xs"
    filter_del(filter_call);
#line 298 "Call.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Filter__Util__Call); /* prototype to pass -Wmissing-prototypes */
XS(boot_Filter__Util__Call)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("Filter::Util::Call::filter_read", XS_Filter__Util__Call_filter_read, file, ";$");
        newXSproto("Filter::Util::Call::real_import", XS_Filter__Util__Call_real_import, file, "$$$");
        newXSproto("Filter::Util::Call::filter_del", XS_Filter__Util__Call_filter_del, file, "");
        newXSproto("Filter::Util::Call::unimport", XS_Filter__Util__Call_unimport, file, ";$@");

    /* Initialisation Section */

#line 251 "Call.xs"
  {
    MY_CXT_INIT;
    fdebug = 0;
    /* temporary hack to control debugging in toke.c */
    if (fdebug)
        filter_add(NULL, (fdebug) ? (SV*)"1" : (SV*)"0");  
  }

#line 331 "Call.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

